---
updatedAt: 2026-06-09T13:03:57.000Z
agentTools:
  projectIndex: https://docs.api.kiln.fi/llms.txt
---

# Stakes

Get the status of OSMO stakes. Units are in uOSMO (10⁻⁶ OSMO).

# OpenAPI definition

```json
{
  "openapi": "3.0.3",
  "info": {
    "x-logo": {
      "url": "assets/logo-preview.png"
    },
    "title": "Kiln API",
    "description": "This API provides reporting staking data on various protocols as\nwell as network wide data, staking transaction crafting features\nand so on.\n\n### ACCESS\n\nIn order to use the Kiln API, you must first get an API token\nfrom your <a href=\"https://dashboard.kiln.fi/\">Kiln dashboard</a>\n(applications section). If you don't have access to our dashboard,\nplease get in touch at hello@kiln.fi.\n\nOnce you have your API token, you can set it as a bearer token in\nyour HTTP request headers, and target the Kiln API endpoint with\nthe current MAJOR version of the API as a prefix to routes:\n\n<blockquote>\ncurl \"https://api.kiln.fi/v1/...\" -H \"Authorization: Bearer $KILN_API_TOKEN\"\n</blockquote>\n\n<i>\nIf you need a development environment, please reach out to\nhello@kiln.fi to have a specific access to our testnet environment\nand dedicated API endpoint.\n</i>\n\n### VERSIONING\n\nVersions of the Kiln API use <b>MAJOR.MINOR.PATCH</b> where:\n\n- <b>MAJOR</b> version is increased when there is major\n  incompatible API changes, major versions will be communicated in\n  advance to all customers with a smooth transition path that\n  spans over a minimum period of 3 MINOR versions or ~3\n  months. <i>Intended frequency: 1 year</i>.\n- <b>MINOR</b> version is increased for backward compatible API\n  changes without notice, or communicated breaking changes with a\n  1 minor version notice and a smooth migration path. Minor\n  versions will be communicated regularly to customers with the\n  changelog. <i>Intended frequency: 1 month</i>.\n- <b>PATCH</b> version is increased for backward compatible\n  hot-fixes, patch versions will be communicated to affected\n  customers.\n\n<i>\nDue to the nature of blockchains (protocol disappearing,\nbreaking protocol upgrades), Kiln may introduce\nbackward-incompatible changes in MINOR versions after following\na 1 MINOR version deprecation path (~1 month). These impacting\nchanges will be narrowed as much as possible to the protocol,\nheavily communicated with clear guidelines and support. Customer\nnot relying on affected protocols will not be affected.\n</i>\n\n### BACKWARD COMPATIBILITY\n\nKiln considers the following changes to be backward compatible:\n\n- Adding new API routes.\n- Adding new optional request parameters to existing API methods.\n- Adding new properties to existing API responses.\n- Changing the order of properties in existing API responses.\n- Adding new event types in existing enums.\n\nNon-breaking changes may be introduced in our API and subject to\nmodification before being officialy communicated and documented\nhere. Your application should not depend on them until part of\nthis specification. The preview Kiln API specifications with\nupcoming and experimental new features can be found\n[here](/preview.html).\n\n### REWARDS BEHAVIOR\n\n- No `start_date`: Returns rewards from validator activation date.\n- No `end_date`: Returns rewards up to yesterday.",
    "termsOfService": "https://kiln.fi/",
    "contact": {
      "email": "contact@kiln.fi"
    },
    "license": {
      "name": "Apache 2.0",
      "url": "http://www.apache.org/licenses/LICENSE-2.0.html"
    },
    "version": "Preview"
  },
  "servers": [
    {
      "url": "https://api.kiln.fi/v1"
    },
    {
      "url": "https://api.testnet.kiln.fi/v1"
    }
  ],
  "tags": [
    {
      "name": "Osmosis (OSMO)",
      "description": "Staking facilities for the OSMO protocol"
    }
  ],
  "paths": {
    "/osmo/stakes": {
      "get": {
        "tags": [
          "Osmosis (OSMO)"
        ],
        "summary": "Stakes",
        "description": "Get the status of OSMO stakes. Units are in uOSMO (10⁻⁶ OSMO).",
        "operationId": "getOsmoStakes",
        "parameters": [
          {
            "$ref": "#/components/parameters/OSMOValidatorsParam"
          },
          {
            "$ref": "#/components/parameters/OSMODelegatorsParam"
          },
          {
            "$ref": "#/components/parameters/AccountsParam"
          },
          {
            "$ref": "#/components/parameters/OSMOPrecisionParam"
          }
        ],
        "responses": {
          "200": {
            "description": "Successful operation",
            "content": {
              "application/json; charset=utf-8": {
                "schema": {
                  "type": "object",
                  "required": [
                    "data"
                  ],
                  "properties": {
                    "data": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/OSMOStake"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Invalid parameters"
          },
          "401": {
            "description": "Unauthorized"
          },
          "500": {
            "description": "Internal server error"
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "bearerAuth": {
        "type": "http",
        "scheme": "bearer"
      }
    },
    "parameters": {
      "AccountsParam": {
        "name": "accounts",
        "in": "query",
        "description": "Comma-separated list of Kiln accounts identifiers",
        "required": false,
        "style": "form",
        "explode": false,
        "schema": {
          "type": "array",
          "items": {
            "type": "string",
            "example": "b7177fd2-fbb3-479f-aa92-db9fb16e229f",
            "format": "uuid"
          }
        }
      },
      "OSMOValidatorsParam": {
        "name": "validators",
        "in": "query",
        "description": "Comma-separated list of validators addresses, these addresses\nare matched with the corresponding delegator addresses. To\nfetch a specific stake, pass your wallet address and the\nvalidator address as parameters.\n",
        "required": false,
        "style": "form",
        "explode": false,
        "schema": {
          "type": "array",
          "items": {
            "type": "string",
            "example": "osmovaloper146mj09yzu3mvz7pmy4dvs4z9wr2mst7rq8p8gy"
          }
        }
      },
      "OSMODelegatorsParam": {
        "name": "delegators",
        "in": "query",
        "description": "Comma-separated list of delegator addresses, these addresses\nare matched with the corresponding validator addresses. To\nfetch a specific stake, pass your wallet address and the\nvalidator address as parameters.\n",
        "required": false,
        "style": "form",
        "explode": false,
        "schema": {
          "type": "array",
          "items": {
            "type": "string",
            "example": "osmo1lnc548nmxqukrvd9czw4tq5vn6kapndg2hzhr3"
          }
        }
      },
      "OSMOPrecisionParam": {
        "name": "precision",
        "in": "query",
        "description": "Precision to use when formatting amounts",
        "required": false,
        "style": "form",
        "explode": false,
        "schema": {
          "type": "string",
          "enum": [
            "chain",
            "micro",
            "atto"
          ]
        }
      }
    },
    "schemas": {
      "OSMOStake": {
        "type": "object",
        "required": [
          "validator_address",
          "delegator_address",
          "rewards",
          "available_rewards",
          "balance",
          "state",
          "net_apy",
          "unbondings",
          "permissions"
        ],
        "properties": {
          "validator_address": {
            "type": "string",
            "description": "Public key of the validator",
            "example": "osmovaloper146mj09yzu3mvz7pmy4dvs4z9wr2mst7rq8p8gy"
          },
          "delegator_address": {
            "type": "string",
            "description": "Public key of the delegator",
            "example": "osmo1mfdn23y2ydnp6j3l3f8rw6r2gzazrmprgxn5xl"
          },
          "delegated_at": {
            "type": "string",
            "description": "Date of first delegation ever for the stake. Unavailable for stakes older than [Theta v7 (12/04/2022)](https://github.com/cosmos/gaia/tree/main/docs/roadmap#cosmos-hub-summary).",
            "format": "date-time",
            "example": "2023-06-16T03:13:23.058547Z"
          },
          "delegated_block": {
            "type": "number",
            "description": "Block of first delegation ever for the stake. Unavailable for stakes older than [Theta v7 (12/04/2022)](https://github.com/cosmos/gaia/tree/main/docs/roadmap#cosmos-hub-summary).",
            "example": 15739267
          },
          "undelegated_at": {
            "type": "string",
            "description": "Date of undelegation for the stake",
            "format": "date-time",
            "example": "2023-07-14T03:56:13.561156Z"
          },
          "undelegated_block": {
            "type": "number",
            "description": "Block of undelegation for the stake",
            "example": 16126416
          },
          "rewards": {
            "type": "string",
            "description": "Total rewards accumulated by this stake since its first ever delegation in uOSMO. Includes currently available rewards not yet withdrawn.",
            "example": "735573808534727891000000"
          },
          "available_rewards": {
            "type": "string",
            "description": "Available rewards in uOSMO that can be withdrawn from this stake",
            "example": "36748808534727891000000"
          },
          "balance": {
            "type": "string",
            "description": "Staked balance on this stake in uOSMO",
            "example": "6300000000000000000000000"
          },
          "net_apy": {
            "type": "number",
            "description": "Net annual percentage yield. Unavailable for stakes older than [Theta v7 (12/04/2022)](https://github.com/cosmos/gaia/tree/main/docs/roadmap#cosmos-hub-summary).",
            "example": 5.76
          },
          "state": {
            "type": "string",
            "description": "State of the Osmosis stake",
            "example": "active",
            "enum": [
              "active",
              "deactivating",
              "inactive"
            ]
          },
          "updated_at": {
            "type": "string",
            "description": "Last date this data was updated",
            "format": "date-time",
            "example": "2023-01-14T01:13:59Z"
          },
          "permissions": {
            "description": "permissions related to the stake currently active, ignored if there is no ongoing grants",
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "source",
                "creation_height",
                "permission"
              ],
              "properties": {
                "source": {
                  "type": "string",
                  "description": "whether the stake is recipient (grantee) or the giver (granter) of the permissions",
                  "example": "granter"
                },
                "creation_height": {
                  "type": "number",
                  "description": "Block at which the unbonding was created",
                  "example": 15000000
                },
                "permission": {
                  "type": "string",
                  "description": "Kind of permission been grantee, can be: \"Staking.MsgDelegate\", \"Staking.MsgUndelegate\", \"Staking.MsgRedelegate\" or \"Distribution.MsgWithdrawDelegatorReward\"",
                  "example": "Staking.MsgDelegate"
                },
                "expires_at": {
                  "type": "string",
                  "description": "Exact time at which the permissions will be revoked",
                  "format": "date-time",
                  "example": "2023-01-10T01:12:34Z",
                  "nullable": true
                },
                "allow_list": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  },
                  "nullable": true,
                  "description": "List of address on which the granted permission can be applied (ie validator on which delegation is allowed)",
                  "example": [
                    "osmovaloper1xyz",
                    "osmovaloper1abc"
                  ]
                },
                "deny_list": {
                  "type": "array",
                  "items": {
                    "type": "string"
                  },
                  "nullable": true,
                  "description": "List of address on which the granted permission cannot be applied (ie validator on which delegation is allowed)",
                  "example": [
                    "osmovaloper1xyz",
                    "osmovaloper1abc"
                  ]
                }
              }
            }
          },
          "unbondings": {
            "description": "unbondings currently active on the stakes. ignored if no unbondings are returned",
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "creation_height",
                "completion_time",
                "balance",
                "initial_balance"
              ],
              "properties": {
                "creation_height": {
                  "type": "number",
                  "description": "Block at which the unbonding was created",
                  "example": 15000000
                },
                "completion_time": {
                  "type": "string",
                  "description": "Exact time at which the unbonding will take effect",
                  "format": "date-time",
                  "example": "2023-01-10T01:12:34Z"
                },
                "balance": {
                  "type": "string",
                  "description": "Amount currently associated with the unbonding (slashes included)",
                  "example": "129300"
                },
                "initial_balance": {
                  "type": "string",
                  "description": "Amount expected at creation (slashes non-included)",
                  "example": "150300"
                }
              }
            }
          }
        }
      }
    }
  },
  "security": [
    {
      "bearerAuth": []
    }
  ]
}
```